package kieker.webgui.beans;

import java.util.ArrayList;
import java.util.List;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import kieker.analysis.model.analysisMetaModel.MIProject;
import kieker.analysis.model.analysisMetaModel.impl.MAnalysisMetaModelFactory;
import org.primefaces.model.DefaultTreeNode;
import org.primefaces.model.TreeNode;

/**
 *
 * @author Nils Christian Ehmke
 */
@ManagedBean
@ApplicationScoped
public class ProjectsBean {

    private final List<MIProject> projects;
    private final MAnalysisMetaModelFactory factory;

    public ProjectsBean() {
        projects = new ArrayList<MIProject>();
        factory = new MAnalysisMetaModelFactory();
    }

    public synchronized boolean addProject(final String projectName) {
        final MIProject project = factory.createProject();
    
        project.setName(projectName);
        
        return projects.add(project);
    }

    public synchronized TreeNode getProjectsRoot() {
        TreeNode root = new DefaultTreeNode("Root", null);

        for (final MIProject project : projects) {
            final TreeNode projectNode = new DefaultTreeNode(project.getName(), root);
            final TreeNode dependenciesNode = new DefaultTreeNode("Dependencies", projectNode);
            final TreeNode usedPluginsNode = new DefaultTreeNode("Used Plugins", projectNode);

            //  for (final String dependency : project.getDependencies()) {
            //       final TreeNode dependencyNode = new DefaultTreeNode(dependency, dependenciesNode);
            //   }
        }

        return root;
    }
}
